//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Override base controls
GuiButtonProfile.soundButtonOver = "AudioButtonOver";
GuiButtonProfile.soundButtonDown = "AudioButtonDown";

//-----------------------------------------------------------------------------
// Chat Hud profiles

new GuiControlProfile ("ChatHudMessageProfile")
{
   fontType = "Arial";
   fontSize = 16;
   //fontColor = "44 172 181";      // default color (death msgs, scoring, inventory)
   //fontColors[1] = "4 235 105";   // client join/drop, tournament mode
   //fontColors[2] = "219 200 128"; // gameplay, admin/voting, pack/deployable
   //fontColors[3] = "77 253 95";   // team chat, spam protection message, client tasks
   //fontColors[4] = "40 231 240";  // global chat
   //fontColors[5] = "200 200 50 200";  // used in single player game

   fontColor = "255 255 255";      // WHITE - Default Colour
   fontColors[1] = "248 204 0";   // ORANGE - Client Messaging. Join/Drop.
   fontColors[2] = "54 239 33"; // PUKE GREEN - General Messages
   fontColors[3] = "255 0 0";   // RED - Server Messages/Warnings
   fontColors[4] = "165 165 165";  // GREY - Free Colour.
   fontColors[5] = "19 136 253";  // BLUE - Game Mode Colours.

   // WARNING! Colors 6-9 are reserved for name coloring 
   autoSizeWidth = true;
   autoSizeHeight = true;
};

new GuiControlProfile ("ChatHudScrollProfile")
{
   opaque = false;
   border = true;
   borderColor = "0 0 0 0";
   bitmap = "common/ui/darkScroll";
   hasBitmapArray = true;
};

//-----------------------------------------------------------------------------
// Common Hud profiles

new GuiControlProfile ("HudScrollProfile")
{
   opaque = false;
   border = true;
   borderColor = "0 255 0";
   bitmap = "common/ui/darkScroll";
   hasBitmapArray = true;
};

new GuiControlProfile ("ChatHudScrollProfile")
{
   opaque = false;
   border = false;
   borderColor = "0 255 0";
   bitmap = "common/ui/darkScroll";
   hasBitmapArray = true;
};

new GuiControlProfile ("HudTextProfile")
{
   opaque = false;
   fillColor = "128 128 128";
   fontColor = "248 204 0";
   border = true;
   borderColor = "0 255 0";
};

new GuiControlProfile (GuiDefaultProfile)
{
   tab = false;
   canKeyFocus = false;
   hasBitmapArray = false;
   mouseOverSelected = false;

   // fill color
   opaque = false;
   fillColor = "211 211 211";
   fillColorHL = "211 211 211";
   fillColorNA = "211 211 211";
   
   // bevel color
   bevelColorHL = "255 255 255";
   bevelColorLL = "0 0 0";

   // font
   fontType = "Arial";
   fontSize = 14;
   fontCharset = CHINESEBIG5;

   fontColor = "0 0 0";
   fontColorHL = "32 100 100";
   fontColorNA = "0 0 0";
   fontColorSEL= "200 200 200";

   // bitmap information
   bitmap = "./darkWindow";
   bitmapBase = "";
   textOffset = "0 0";

   // used by guiTextControl
   modal = true;
   justify = "left";
   autoSizeWidth = false;
   autoSizeHeight = false;
   returnTab = false;
   numbersOnly = false;
   cursorColor = "0 0 0 255";

   // sounds
   soundButtonDown = "";
   soundButtonOver = "";
};

new GuiControlProfile (GuiWindowProfile)
{
   opaque = true;
   border = 2;
   fillColor = "211 211 211";
   fillColorHL = "221 202 173";
   fillColorNA = "221 202 173";
   fontColor = "211 211 211";
   fontColorHL = "211 211 211";
   text = "GuiWindowCtrl test";
   bitmap = "./darkWindow";
   textOffset = "8 2";
   hasBitmapArray = true;
   justify = "left";
   fontType = "Impact";
   fontSize = 18;
   fontColor = "255 255 255";
};

new GuiControlProfile (GuiTextEditProfile)
{
   opaque = true;
   border = 1;
   fillColor = "255 255 255";
   fillColorHL = "0 0 0";
   borderThickness = 1;
   borderColor = "0 0 0";
   fontColor = "0 0 0";
   fontColorHL = "255 255 255";
   fontColorNA = "50 50 50";
   textOffset = "0 2";
   autoSizeWidth = false;
   autoSizeHeight = true;
   tab = true;
   canKeyFocus = true;
};

new GuiControlProfile (GuiBlockButton)
{
   opaque = true;
   justify = "center";
   fontType = "Impact";
   fontSize = 18;
   fontColor = "0 0 0";
};

new GuiControlProfile (GuiPopUpMenuProfile)
{
   opaque = true;
   mouseOverSelected = true;
   fontType = "Impact";
   fillColor = "200 200 200";
   border = 4;
   borderThickness = 2;
   borderColor = "0 0 0";
   fontSize = 18;
   fontColor = "0 0 0";
   fontColorHL = "32 100 100";
   fontColorSEL = "32 100 100";
   fixedExtent = true;
   justify = "center";
   bitmap = ($platform $= "macos") ? "./osxScroll" : "./darkScroll";
   hasBitmapArray = true;
};

new GuiControlProfile (GuiBlockTab)
{
   opaque = true;
   justify = "center";
   fontType = "Impact";
   fontSize = 18;
   fontColor = "0 0 0";
};

//-----------------------------------------------------------------------------
// Center and bottom print

new GuiControlProfile ("CenterPrintProfile")
{
   opaque = false;
   fillColor = "128 128 128";
   fontColor = "248 204 0";
   border = true;
   borderColor = "0 255 0";
};

new GuiControlProfile ("CenterPrintTextProfile")
{
   opaque = false;
   fontType = "Arial";
   fontSize = 12;
   fontColor = "248 204 0";
};

new GuiControlProfile ("GuiMM_Version")
{
   opaque = false;
   fontType = "Arial";
   fontSize = 14;
   fontColor = "255 255 255";
   fontColorHL = "32 100 100";
};


// Inventory display
new GuiControlProfile ("InventoryTextProfile")
{
   opaque = false;
   fillColor = "128 128 128";
   fontColor = "255 255 255";
   border = false;
   borderColor = "0 255 0";
   justify = "Center";
};

new GuiControlProfile ("ClockProfile")
{
	bitmap = "~/client/ui/GUIbrickSide.png";
	bitmapBase = "~/client/ui/GUIbrickSide.png";
};

// Loading
new GuiControlProfile ("GuiProgressProfile")
{
	opaque = false;
	fillColor = "0 38 150 130"; // Default color
	border = 2;
	borderThickness = 2;
	borderColor = "0 0 0 255"; // Default color 78 88 120 255
};

new GuiControlProfile ("GuiProgressTextProfile1")
{
   fontColor = "255 255 255"; // Text loading color
   justify = "center";
};

new GuiControlProfile ("GuiProgressTextName1")
{
   fontColor = "255 185 35"; // Text loading color
   fontColorHL = "32 100 100";
   justify = "left";
};